'use strict';
import React from 'react';
import { connect } from  'react-redux';
import SwiperComponent from '../../components/CommonComponent/SwiperComponent/SwiperComponent'
import ImgToolComponent from '../../components/CommonComponent/CommonSmallComponent/ImgToolComponent/CommonSmalContainer'
import EditProblemItem from '../../components/OtherQuestionComponent/EditProblemComponent'
import HeaderComponent from '../../components/CommonComponent/HeaderComponent/HeaderComponent'
import TextArea from "../TextAreaContainer/TextAreaContainer";
import {initGetOtherProblem, addNewProbem, editProblemItem} from '../../actions/otherQuestion'
require('./index.css');
export default class OtherQuestionContainer extends React.Component{
    constructor(props){
        super(props)
        this.state = {
            showTextArea:false,
            tmpText:"",
            currentProblemId:''
        }
    }
    componentWillMount() {
        let {dispatch,initStart,state} = this.props;
        // 请求 初始数据接口
        let postData = {};
        initStart(postData);

    }
    componentDidMount(){
    }
    componentDidUpdate() {
    }
    componentWillReceiveProps(nextProps){
        let {state} = nextProps;
        let {otherQuestion} = state;

    }
    componentWillUnmount(){
    }
    /*
    * 输入故障备注信息部分
    * */
    // 1. 显示编辑备注组件
    handleShowRemark(troubleId){
        let {state} = this.props;
        let {otherQuestion} = state;
        let problemList = otherQuestion.data_allProblemList;
        console.log(this.props);
        let currentProblem = problemList[troubleId];
        let tmpText = currentProblem.remark;
        this.setState({
            showTextArea : true,
            tmpText: tmpText,
            currentProblemId:troubleId
        })
    }
    // 2. 在编辑备注页面组件 点击返回
    handleEditGoBack(){
        this.setState({
            showTextArea:false
        })
        console.log("点击文本框页的返回键");

    }
    // 3. 在编辑备注组件页面 点击保存
    handleSaveRemarkText(text){
        let {editProblemItem} = this.props;
        let data = {};
        data.type = "remark";
        data.troubelId = this.state.currentProblemId;
        data.remarkText = text;
        editProblemItem(data);
        this.setState({
            showTextArea:false
        })
    }
    /*
    * 点击录入更多 添加新故障
    * */

    handleAddNewTroble(){
        let postData = {};
        let {addNewProblem} = this.props;
        postData.employeeId = "dfdf";
        postData.employeeId = "dfdf";

        addNewProblem();
    }
    /*
    * 删除已经编辑的的问题
    * */
    handleDeleteProblem(troubleId){
        let {deleteProblem} = this.props;
        console.log(deleteProblem);
        let postData = {};
        postData.feedIds =[];
        postData.feedIds.push(troubleId);
        deleteProblem(postData);
        console.log("删除编辑的问题");

    }
    handleSubmitProblemList(){
        let {submitProblemList,state}=this.props;
        let problemList = state.otherQuestion.data_allProblemList;
        console.log("=========================数量")
        console.log(problemList);
        submitProblemList(problemList)

    }
    /*
    *添加照片
    * */
    handleAddImg(){
        console.log("添加照片")
    }


    /*
    *刷新当前图片
    * */
    handleRefreshProbelmImg(){
        console.log("刷新当前问题备注图片")
    }
    /*
    * 删除图片
    * */
    handleDeleteImg(){
        console.log("删除图片")
    }



    /*
    * 整体提交已经编辑的问题
    * */
    /*handleSubmitProblemList(){
        console.log("=======提交已经编辑的问题==")
    }*/
    /*
    * 直接跳过
    * */

    handleOverPass(){
        let {deleteProblem,state} = this.props;
        let problemKeyList = Object.keys(state.otherQuestion.data_allProblemList);
        let postData = {};
        postData.feedIds =problemKeyList;
        deleteProblem(postData);
    }


    render(){
        //let 难道初始化的数据：
        let {state,addNewProblem,editProblemItem,deleteProblem} = this.props;
        let {otherQuestion,userInfo,storeInfo} = state;
        let {problems} = otherQuestion;
        let feeds = otherQuestion.feeds;
        let problemList = otherQuestion.data_allProblemList;
        let problemListLength = 0;
        let editProblemItemUI = [];
        //生成基本Ui
        for (let key in problemList){
            problemListLength++;
            let item = problemList[key];
            let troubleId = item.id;
            let currentRemark = item.remark;
            let currentItemUi = <EditProblemItem
                editProblemItem = {editProblemItem}
                trouleId = {troubleId}
                clickEdit = {this.handleShowRemark.bind(this,troubleId)}
                problemInfo = {problems}
                baseInfo = {item}
                remarkText = {currentRemark}
                deleteProblem = {()=>(this.handleDeleteProblem.bind(this,troubleId))}
                addImg = {()=>(this.handleAddImg.bind(this))}
                reRreshImg = {()=>(this.handleRefreshProbelmImg.bind(this))}
                deleteImg = {()=>(this.handleDeleteImg.bind(this))}
                key={key}/>
            editProblemItemUI.push(currentItemUi);
        }

        let swiperCount = problemListLength;
        let swiperOptions = {
            width : 1396,
            spaceBetween: 30,
            freeMode:true,
            // slidesPerView: 2.6,
        };
        let swiperContainer = CONFIG.swiperContainers.editProblemSwiperContainer;
        return (
            this.state.showTextArea?(
                <TextArea
                    text={this.state.tmpText}
                    goBack={this.handleEditGoBack.bind(this)}
                    saveText={this.handleSaveRemarkText.bind(this)}
                ></TextArea>
            ):(
                <div className={"OtherQuestionContainer"}>
                    <HeaderComponent
                        showHeader={CONFIG.headerStatus[1]}
                        userinfo={userInfo}
                        storeInfo={storeInfo}
                    />
                    <div className={"otherQuestionTitleContainer"}>你是否有其他问题希望反馈(<i>*</i>必填项)</div>
                    <div className={"editOtherQuestionContainer clearfix"}>
                        <SwiperComponent
                            swiperContainer={swiperContainer} swiperOptions={swiperOptions} swiperCount={swiperCount}
                        >
                            {editProblemItemUI}
                        </SwiperComponent>
                    </div>
                    <div className={"opeationContainer clearfix"}>
                        <button className={"addMoreBtn"} onClick={this.handleAddNewTroble.bind(this)}><span>+</span>录入更多</button>
                        <button className={"noMoreBtn"} onClick={this.handleSubmitProblemList.bind(this)}>没有更多</button>
                    </div>
                    <div className={"overPass"} onClick={this.handleOverPass.bind(this)}>跳过</div>

                </div>
            )

        )
    }
}